﻿namespace VSMPrototypePattern.Models
{
    public class Person : BaseModel<Person>, IDeepCloneable<Person>
    {
        private string _firstName;
        private string _lastName;
        private Address _address;

        public string FirstName
        {
            get { return _firstName; }
            set { _firstName = value; NotifyPropertyChanged(); }
        }

        public string LastName
        {
            get { return _lastName; }
            set { _lastName = value; NotifyPropertyChanged(); }
        }

        public Address Address
        {
            get { return _address; }
            set { _address = value; NotifyPropertyChanged(); }
        }

        public Person DeepClone()
        {
            Person deepClone = (Person) MemberwiseClone();
            deepClone.Address = Address.ShallowClone();
            return deepClone;
        }
    }
}
